/*****************************************************************************
*  sha.h                                                      VERSION 2.00b  *
*----------------------------------------------------------------------------*
*  S E C U R E   H A S H   S T A N D A R D  (SHA)                            *
*  FEDERAL INFORMATION PROCESSING STANDARDS PUBLICATION 180                  *
*  APRIL 1993                                                                *
*----------------------------------------------------------------------------*
*  This software was produced at the National Institute of Standards and     *
*  Technology (NIST) as part of research efforts and is for demonstration    *
*  purposes only.  Our primary goals in its design did not include widespread*
*  use outside of our own laboratories.  Acceptance of this software implies *
*  that you agree to use it for non-commercial purposes only and that you    *
*  agree to accept it as nonproprietary and unlicensed, not supported by NIST*
*  and not carrying any warranty, either expressed or implied, as to its     *
*  performance or fitness for any particular purpose.                        *
*----------------------------------------------------------------------------*
*  Produced by the National Institute of Standards and Technology (NIST),    *
*  Computer Systems Laboratory (CSL) Security Technology Group.              *
*****************************************************************************/

#ifndef _SHA_H_
#define _SHA_H_

#define VERSIONINFO_1	1
#include "config.h"

#define SHADIGITLEN  4          	/* in bytes */
#define SHABLOCKLEN  160        	/* in bits */
#define SHABYTEBLOCKLEN  SHABLOCKLEN/8  /* in bits */
#define SHAHASHLEN   20         	/* in bytes */

typedef struct {
    ULONG Numbytes;
    ULONG Numblocks[2];  	/* each block contains 64 bytes */
    ULONG Mblock[16];
    ULONG H[5];
} SHA_CTX;

int SHAInit2(SHA_CTX*, ULONG*);
int  SHAUpdate(SHA_CTX*, unsigned char*, int);

#endif	/* _SHA_H_  */
